diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
new file mode 100644
index 000000000..a698d9b3b
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
@@ -0,0 +1,408 @@
+package net.minecraft.client.gui.keyboard;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ControllerGlyphElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.keyboard.keys.Key;
+import net.minecraft.client.gui.text.ITextField;
+import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.Map;
+
+public class ScreenKeyboard extends Screen implements ITextField {
+    private static final int HORIZONTAL_BUFFER = 5;
+
+    public final @Nullable Screen parent;
+    public final @Nullable StringConsumer resultStringAction;
+    public final @Nullable StringConsumer backspaceAction;
+    public final @Nullable KeyAction keyAction;
+
+    private final KeyboardLayout keyboardLayout;
+
+    private @NotNull String workingString = "";
+    public final @NotNull TextFieldEditor editor;
+    private int cursorCounter = 0;
+
+    private final boolean wasRepeating;
+
+    public final Map<String, Boolean> activeModifiers = new HashMap<>();
+    public final Map<String, Boolean> activeLocks = new HashMap<>();
+
+    public ControllerGlyphElement glyphRenderer;
+
+    private int group = 0;
+
+    public ScreenKeyboard(@Nullable Screen parent, @Nullable TextFieldEditor editor, @Nullable StringConsumer enterAction, @Nullable KeyAction keyAction, @Nullable StringConsumer backspaceAction) {
+        this.parent = parent;
+        this.resultStringAction = enterAction;
+        this.backspaceAction = backspaceAction;
+        this.keyAction = keyAction;
+        this.editor = editor == null ? new TextFieldEditor(this) : editor;
+        this.wasRepeating = Keyboard.areRepeatEventsEnabled();
+
+
+        this.keyboardLayout = KeyboardLayout.defaultLayout;
+        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onOpen(mc, this));
+    }
+
+    @Override
+    public void opened(Minecraft mc, int width, int height) {
+        Keyboard.enableRepeatEvents(true);
+        if (parent != null) {
+            parent.mc = mc;
+            parent.font = mc.font;
+            parent.width = width;
+            parent.height = height;
+        }
+        this.glyphRenderer = new ControllerGlyphElement(mc);
+        super.opened(mc, width, height);
+    }
+
+    @Override
+    public boolean isPauseScreen() {
+        if (parent != null) {
+            return parent.isPauseScreen();
+        }
+        return super.isPauseScreen();
+    }
+
+    @Override
+    public void tick() {
+        cursorCounter++;
+        if (parent != null) {
+            parent.tick();
+        }
+    }
+
+    @Override
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE || eventKey == Keyboard.KEY_RETURN) {
+            close();
+            return;
+        }
+        typeChar(eventKey, eventCharacter);
+    }
+
+    public void typeChar(int key, char chr) {
+        if (editor.handleInput(key, chr)) {
+            if (keyAction != null) {
+                keyAction.apply(chr, key, editor.getText());
+            }
+
+            for (String id : activeModifiers.keySet()) {
+                if (!isModifierLocked(id)) {
+                    setModifierState(id, false);
+                }
+            }
+        }
+    }
+
+    public void backspace() {
+        editor.deleteCharsBeforeCursor(1);
+        if (backspaceAction != null) {
+            backspaceAction.apply(editor.getText());
+        }
+    }
+
+    public void setModifierState(String id, boolean flag) {
+        activeModifiers.put(id, flag);
+        activeLocks.putIfAbsent(id, false);
+    }
+
+    public void setModifierLock(String id, boolean flag) {
+        activeModifiers.putIfAbsent(id, false);
+        activeLocks.put(id, flag);
+    }
+
+    public boolean isModifierActive(String id) {
+        return activeModifiers.getOrDefault(id, false) || isModifierLocked(id);
+    }
+
+    public boolean isModifierLocked(String id) {
+        return activeLocks.getOrDefault(id, false);
+    }
+
+    @Override
+    public void removed() {
+        if (mc.controllerInput != null) {
+            mc.controllerInput.lockCursor = false;
+            mc.controllerInput.hideCursor = false;
+        }
+        if (resultStringAction != null) {
+            resultStringAction.apply(editor.getText());
+        }
+        Keyboard.enableRepeatEvents(wasRepeating);
+    }
+
+    public void close()
+    {
+        this.removed();
+        mc.currentScreen = parent;
+    }
+
+    public void setGroup(int group) {
+        group = MathHelper.clamp(group, 0, keyboardLayout.getHighestGroup());
+        this.group = group;
+    }
+
+    public void shiftGroup(int amount) {
+        setGroup(getShiftedGroup(amount));
+    }
+
+    public int getShiftedGroup(int amount) {
+        int group = this.group + amount;
+        return (group + keyboardLayout.getHighestGroup() + 1) % (keyboardLayout.getHighestGroup() + 1);
+    }
+
+    public int getGroup() {
+        return group;
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        if (!mouseOnKeyboard(mx, my)) {
+            close();
+            return;
+        }
+        int _x = ((width - keyboardLayout.getWidth()) / 2);
+        int _y = height - keyboardLayout.getHeight() - 5;
+        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onClick(mc, this, _x, _y, mx, my, buttonNum));
+    }
+
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum) {
+        int _x = ((width - keyboardLayout.getWidth()) / 2);
+        int _y = height - keyboardLayout.getHeight() - 5;
+        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onRelease(mc, this, _x, _y, mx, my, buttonNum));
+    }
+
+    public boolean mouseOnKeyboard(int mx, int my) {
+        int keyboardWidth = keyboardLayout.getWidth();
+        int keyboardHeight = keyboardLayout.getHeight();
+
+        int _x = ((width - keyboardWidth) / 2) - HORIZONTAL_BUFFER;
+        int _y = height - keyboardHeight - 5 - 34;
+        return
+            _x <= mx && mx < _x + (keyboardWidth + HORIZONTAL_BUFFER * 2) &&
+            _y <= my && my < _y + (keyboardHeight + 34 + 5);
+    }
+
+    @Override
+    public void render(int mx, int my, float partialTick) {
+        if (parent != null) {
+            GL11.glPushMatrix();
+            GL11.glTranslatef(0, 0, -100);
+            parent.render(mx, my, partialTick);
+            GL11.glPopMatrix();
+        }
+        drawRect(0, 0, width, height, 0x90_00_00_00);
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+
+        int keyboardWidth = keyboardLayout.getWidth();
+        int keyboardHeight = keyboardLayout.getHeight();
+
+        int _x = ((width - keyboardWidth) / 2);
+        int _y = height - keyboardHeight - 5;
+
+        drawGuiIcon(
+            _x - 5 - HORIZONTAL_BUFFER,
+            _y - 4 - 30,
+            keyboardWidth + 10 + HORIZONTAL_BUFFER * 2,
+            36,
+            TextureRegistry.getTexture("minecraft:gui/screen/keyboard/keyboard_background_embedded"));
+
+        drawGuiIcon(
+            _x - 5 - HORIZONTAL_BUFFER,
+            _y - 4,
+            keyboardWidth + 10 + HORIZONTAL_BUFFER * 2,
+            keyboardHeight + 8,
+            TextureRegistry.getTexture("minecraft:gui/screen/keyboard/keyboard_background"));
+
+        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.render(mc, this, _x, _y, mx, my));
+
+        drawStringCentered(mc.font, editor.getText(), _x + keyboardWidth/2, _y - 20, 0xFFFFFF);
+
+        boolean drawCursor = (cursorCounter / 6) % 2 == 0;
+        if (drawCursor)
+        {
+            int width = font.getStringWidth(editor.getText());
+            if (editor.getCursor() < editor.getText().length())
+            {
+                width = font.getStringWidth(editor.getText().substring(0, editor.getCursor()));
+            }
+            drawString(font, "_", _x + keyboardWidth/2 - font.getStringWidth(editor.getText())/2 + width, _y - 20 + 1, 0xE0E0E0);
+        }
+
+
+//        drawString(mc.font, String.valueOf(page), _x + 2, _y - 32, 0xFFFFFF);
+    }
+
+    @Override
+    public void guiSpecificControllerInput(ControllerInput controller) {
+        int keyboardWidth = keyboardLayout.getWidth();
+        int keyboardHeight = keyboardLayout.getHeight();
+
+        int _x = ((width - keyboardWidth) / 2);
+        int _y = height - keyboardHeight - 5;
+
+        if(controller.buttonA.pressedThisFrame()) {
+            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+        if(controller.buttonA.releasedThisFrame()) {
+            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+        }
+
+        if (!controller.lockCursor) {
+            if (controller.digitalPad.up.pressedThisFrame()) {
+                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+
+                final int stepSize = 9;
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardHeight/9; i++) {
+                    int newY = y - stepSize * i;
+                    while (newY < _y) {
+                        newY += keyboardHeight;
+                    }
+                    while (newY > height - 5) {
+                        newY -= keyboardHeight;
+                    }
+                    Key newHover = getHoveredKey(x, newY);
+                    if (newHover != null && newHover != hovered) {
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        break;
+                    }
+                }
+            }
+            if (controller.digitalPad.down.pressedThisFrame()) {
+                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+
+                final int stepSize = 9;
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardHeight/9; i++) {
+                    int newY = y + stepSize * i;
+                    while (newY < _y) {
+                        newY += keyboardHeight;
+                    }
+                    while (newY > height - 5) {
+                        newY -= keyboardHeight;
+                    }
+                    Key newHover = getHoveredKey(x, newY);
+                    if (newHover != null && newHover != hovered) {
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        break;
+                    }
+                }
+            }
+            if (controller.digitalPad.left.pressedThisFrame()) {
+                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+
+                final int stepSize = 9;
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardWidth/9; i++) {
+                    int newX = x - stepSize * i;
+                    while (newX < _x) {
+                        newX += keyboardWidth;
+                    }
+                    while (newX > _x + keyboardWidth) {
+                        newX -= keyboardWidth;
+                    }
+                    Key newHover = getHoveredKey(newX, y);
+                    if (newHover != null && newHover != hovered) {
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        break;
+                    }
+                }
+            }
+            if (controller.digitalPad.right.pressedThisFrame()) {
+                Key hovered = getHoveredKey((int)controller.cursorX, (int)controller.cursorY);
+
+                final int stepSize = 9;
+                int x = hovered != null ? (_x + hovered.getX() + hovered.getWidth()/2): MathHelper.clamp((int) controller.cursorX, keyboardLayout.getMinX() + _x, keyboardLayout.getMaxX() + _x);
+                int y = hovered != null ? (_y + hovered.getY() + hovered.getHeight()/2) : MathHelper.clamp((int) controller.cursorY, keyboardLayout.getMinY() + _y, keyboardLayout.getMaxY() + _y);
+                for (int i = 0; i < keyboardWidth/9; i++) {
+                    int newX = x + stepSize * i;
+                    while (newX < _x) {
+                        newX += keyboardWidth;
+                    }
+                    while (newX > _x + keyboardWidth) {
+                        newX -= keyboardWidth;
+                    }
+                    Key newHover = getHoveredKey(newX, y);
+                    if (newHover != null && newHover != hovered) {
+                        controller.cursorX = _x + newHover.getX() + newHover.getWidth()/2f;
+                        controller.cursorY = _y + newHover.getY() + newHover.getHeight()/2f;
+                        break;
+                    }
+                }
+            }
+        }
+
+        Arrays.stream(keyboardLayout.getKeys()).forEach(key -> key.onButtonUse(mc, this, _x, _y));
+    }
+
+    @Override
+    public void playControllerButtonSound(ControllerInput controller) {
+        if (controller.buttonStart.pressedThisFrame()) {
+            mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+        if (controller.buttonB.pressedThisFrame()) {
+            mc.sndManager.playSound("ui.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+        }
+    }
+
+    public @Nullable Key getHoveredKey(int mx, int my) {
+        int keyboardWidth = keyboardLayout.getWidth();
+        int keyboardHeight = keyboardLayout.getHeight();
+
+        int _x = ((width - keyboardWidth) / 2);
+        int _y = height - keyboardHeight - 5;
+        for (Key key : keyboardLayout.getKeys()) {
+            if (key.isHovered(_x, _y, mx, my)) return key;
+        }
+        return null;
+    }
+
+    @Override
+    public void setText(String text) {
+        this.workingString = text;
+    }
+
+    @Override
+    public String getText() {
+        return workingString;
+    }
+
+    @Override
+    public int maxLength() {
+        return Integer.MAX_VALUE;
+    }
+
+    public boolean isCharacterAllowed(char c) {
+        return ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) >= 0 || Character.isLetterOrDigit(c);
+    }
+
+    public interface KeyAction {
+        void apply(char c, int key, String workingString);
+    }
+
+    public interface StringConsumer {
+        void apply(String s);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java
new file mode 100644
index 000000000..97163a2b3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/keys/BackspaceKey.java
@@ -0,0 +1,97 @@
+package net.minecraft.client.gui.keyboard.keys;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+import net.minecraft.core.sound.SoundCategory;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+
+public class BackspaceKey extends Key{
+
+    public BackspaceKey(int x, int y, int width, int height) {
+        super(x, y, width, height);
+        setTextures(
+            "minecraft:gui/widgets/keyboard/key_backspace/up",
+            "minecraft:gui/widgets/keyboard/key_backspace/down",
+            "minecraft:gui/widgets/keyboard/key_backspace/up_hovered",
+            "minecraft:gui/widgets/keyboard/key_backspace/down_hovered");
+    }
+
+    @Override
+    public void pressAction(Minecraft mc, ScreenKeyboard keyboard, int originX, int originY, int mouseX, int mouseY) {
+        keyboard.backspace();
+        mc.sndManager.playSound("ui.ui_back", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
+    }
+
+    public static class Serializer implements JsonSerializer<BackspaceKey>, JsonDeserializer<BackspaceKey> {
+        public static final int DEFAULT_WIDTH = 25;
+        public static final int DEFAULT_HEIGHT = 18;
+
+        public static final String DEFAULT_TEXTURE_UP = "minecraft:gui/widgets/keyboard/key_backspace/up";
+        public static final String DEFAULT_TEXTURE_DOWN = "minecraft:gui/widgets/keyboard/key_backspace/down";
+        public static final String DEFAULT_TEXTURE_UP_HOVERED = "minecraft:gui/widgets/keyboard/key_backspace/up_hovered";
+        public static final String DEFAULT_TEXTURE_DOWN_HOVERED = "minecraft:gui/widgets/keyboard/key_backspace/down_hovered";
+
+        @Override
+        public BackspaceKey deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+            JsonObject obj = json.getAsJsonObject();
+            int x = obj.get("x").getAsInt();
+            int y = obj.get("y").getAsInt();
+            int width = obj.has("width") ? obj.get("width").getAsInt() : DEFAULT_WIDTH;
+            int height = obj.has("height") ? obj.get("height").getAsInt() : DEFAULT_HEIGHT;
+            ButtonEnum button = obj.has("button") ? Key.ButtonEnum.valueOf(obj.get("button").getAsString().toUpperCase(Locale.ROOT)) : null;
+
+            String texUp = DEFAULT_TEXTURE_UP;
+            String texDown = DEFAULT_TEXTURE_DOWN;
+            String texUpHovered = DEFAULT_TEXTURE_UP_HOVERED;
+            String texDownHovered = DEFAULT_TEXTURE_DOWN_HOVERED;
+
+            if (obj.has("textures")) {
+                JsonObject textures = obj.getAsJsonObject("textures");
+                if (textures.has("up")) texUp = textures.get("up").getAsString();
+                if (textures.has("down")) texDown = textures.get("down").getAsString();
+                if (textures.has("up_hovered")) texUpHovered = textures.get("up_hovered").getAsString();
+                if (textures.has("down_hovered")) texDownHovered = textures.get("down_hovered").getAsString();
+            }
+            BackspaceKey key = new BackspaceKey(x, y, width, height);
+            key.setTextures(texUp, texDown, texUpHovered, texDownHovered);
+            key.setControllerButton(button);
+            return key;
+        }
+
+        @Override
+        public JsonElement serialize(BackspaceKey src, Type typeOfSrc, JsonSerializationContext context) {
+            JsonObject object = new JsonObject();
+            object.addProperty("type", Key.Serializer.KEY_CLASS_TO_ID.get(src.getClass()));
+
+            object.addProperty("x", src.x);
+            object.addProperty("y", src.y);
+            if (src.width != DEFAULT_WIDTH) object.addProperty("width", src.width);
+            if (src.height != DEFAULT_HEIGHT) object.addProperty("height", src.height);
+            if (src.controllerButton != null) object.addProperty("button", src.controllerButton.name().toLowerCase(Locale.ROOT));
+
+            boolean ku = !src.keyUp.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP);
+            boolean kd = !src.keyDown.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN);
+            boolean kuh = !src.keyUpHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_UP_HOVERED);
+            boolean kdh = !src.keyDownHovered.sourceNamespaceId.toString().equals(DEFAULT_TEXTURE_DOWN_HOVERED);
+            if (ku || kd || kuh || kdh) {
+                JsonObject textureObject = new JsonObject();
+                if (ku) textureObject.addProperty("up", src.keyUp.sourceNamespaceId.toString());
+                if (kd) textureObject.addProperty("down", src.keyDown.sourceNamespaceId.toString());
+                if (kuh) textureObject.addProperty("up_hovered", src.keyUpHovered.sourceNamespaceId.toString());
+                if (kdh) textureObject.addProperty("down_hovered", src.keyDownHovered.sourceNamespaceId.toString());
+                object.add("textures", textureObject);
+            }
+
+            return object;
+        }
+    }
+}
